import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;
import java.awt.event.WindowListener;
import java.awt.event.WindowEvent;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.AdjustmentListener;
import java.awt.event.AdjustmentEvent;
import java.awt.Color;

public class ColorAdapter implements WindowListener,ActionListener,AdjustmentListener {

	boolean first=true;

	/********
	** KEY **
	********/
	
	public void actionPerformed(ActionEvent evt) {
		Object source=evt.getSource();

		if (source==ColorPanel.okButton) {
//			Core.restartBehaviour(CoreConstant.CORE_COLORC,ColorPanel.getColor());
			DrawFrameAdapter.restart();
			ColorFrame.off();
		}else if (source==ColorPanel.applyButton) {
			DrawFrameAdapter.restart();
//			Core.restartBehaviour(CoreConstant.CORE_COLORC,ColorPanel.getColor());
		}else if (source==ColorPanel.cancelButton) {
			ColorFrame.off();
		}
	}

	/**********
	** MOUSE **
	**********/

/*	public void mouseClicked(MouseEvent evt) {
			Object source=evt.getSource();

		if (source==ColorPanel.redScrollbar)
			ColorPanel.redCanvas.setColor(new Color(ColorPanel.redScrollbar.getValue(),0,0));
		else if (source==ColorPanel.greenScrollbar)
			ColorPanel.greenCanvas.setColor(new Color(0,ColorPanel.greenScrollbar.getValue(),0));
		else if (source==ColorPanel.blueScrollbar) 
			ColorPanel.blueCanvas.setColor(new Color(0,0,ColorPanel.blueScrollbar.getValue()));
		ColorPanel.colorCanvas.setColor(new Color(ColorPanel.redScrollbar.getValue(),ColorPanel.greenScrollbar.getValue(),ColorPanel.blueScrollbar.getValue()));
	}

	public void mousePressed(MouseEvent evt) {
			Object source=	evt.getSource();

		if (source==ColorPanel.redScrollbar)
			ColorPanel.redCanvas.setColor(new Color(ColorPanel.redScrollbar.getValue(),0,0));
		else if (source==ColorPanel.greenScrollbar)
			ColorPanel.greenCanvas.setColor(new Color(0,ColorPanel.greenScrollbar.getValue(),0));
		else if (source==ColorPanel.blueScrollbar) 
			ColorPanel.blueCanvas.setColor(new Color(0,0,ColorPanel.blueScrollbar.getValue()));
		ColorPanel.colorCanvas.setColor(new Color(ColorPanel.redScrollbar.getValue(),ColorPanel.greenScrollbar.getValue(),ColorPanel.blueScrollbar.getValue()));
	}

	public void mouseReleased(MouseEvent evt) {
			Object source=	evt.getSource();

		if (source==ColorPanel.redScrollbar)
			ColorPanel.redCanvas.repaint();
		else if (source==ColorPanel.greenScrollbar) 
			ColorPanel.greenCanvas.repaint();
		else if (source==ColorPanel.blueScrollbar) 
			ColorPanel.blueCanvas.repaint();
		ColorPanel.colorCanvas.repaint();
	}

	public void mouseEntered(MouseEvent evt) {
	}

	public void mouseExited(MouseEvent evt) {
	} */

	/***********
	** WINDOW **
	***********/

	public void windowOpened(WindowEvent evt) {
		
	}

	public void windowClosed(WindowEvent evt) {
	}

	public void windowClosing(WindowEvent evt) {

		ColorFrame.off();
	}

	public void windowIconified(WindowEvent evt) {

	}

	public void windowDeiconified(WindowEvent evt) {
	}

	public void windowActivated(WindowEvent evt) {
	}

	public void windowDeactivated(WindowEvent evt) {
	}
	
	public void adjustmentValueChanged(AdjustmentEvent evt) {
		Object source=	evt.getSource();
		
		if (source==ColorPanel.redScrollbar){
			ColorPanel.redCanvas.setColor(new Color(ColorPanel.redScrollbar.getValue(),0,0));
			ColorPanel.redCanvas.repaint();
		}else if (source==ColorPanel.greenScrollbar){
			ColorPanel.greenCanvas.setColor(new Color(0,ColorPanel.greenScrollbar.getValue(),0));
			ColorPanel.greenCanvas.repaint();
		}else if (source==ColorPanel.blueScrollbar) {
			ColorPanel.blueCanvas.setColor(new Color(0,0,ColorPanel.blueScrollbar.getValue()));
			ColorPanel.blueCanvas.repaint();
		}
		ColorPanel.colorCanvas.setColor(new Color(ColorPanel.redScrollbar.getValue(),ColorPanel.greenScrollbar.getValue(),ColorPanel.blueScrollbar.getValue()));
	}
	
}