import java.awt.Canvas;
import java.awt.Color;
import java.awt.color.ColorSpace;
import java.awt.Graphics;

/**
 * <p>Title: Geo</p>
 * <p>Description: Geometric project</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Mason & C.</p>
 * @author Mason
 * @version 0.1t
 */

public class ColorCanvas extends Canvas {

Color color;

	public ColorCanvas() {
	}

	public void paint(Graphics g) {
	
		g.setColor(CoreConstant.CORE_COLORCANVAS_BORDER);
		g.drawRect(Constant.COLORCANVAS_STARTRECTX-1,Constant.COLORCANVAS_STARTRECTY-1,Constant.COLORCANVAS_WIDTHRECTX+2,Constant.COLORCANVAS_WIDTHRECTY+2);
		g.setColor(color);
		g.fillRect(Constant.COLORCANVAS_STARTRECTX,Constant.COLORCANVAS_STARTRECTY,Constant.COLORCANVAS_WIDTHRECTX,Constant.COLORCANVAS_WIDTHRECTY);
	}	

	public void setColor(Color color) {
	
		this.color=color;
		repaint();
	}
}