/**
 * <p>Title: Geo</p>
 * <p>Description: Geometric project</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: Mason & C.</p>
 * @author Mason
 * @version 0.1t
 */
import java.io.File;
import java.awt.Color;

public class CoreConstant extends Constant {

	public static String CORE_INITFILE="." + File.separator + "modules.ini";
	public static int CORE_HEADERBUFFERSIZE=1;
	public static int CORE_BUFFERSIZE=1024;
	public static int CORE_INT_VERBOSE= 2;
	public static String CORE_READFILE="read";
	public static String CORE_ECHO="echo";
	public static String CORE_SEPARETOR=" ";
	public static String CORE_SYNTAX_ERROR="Syntax Error";
	public static String CORE_PARAMETER_ERROR="Parameters Error";
	public static String CORE_COLOR_FOREGROUND="foreground";
	public static String CORE_COLOR_BACKGROUND="background";

	public static String CORE_APPLY="apply";
	public static String CORE_VERBOSE="verbose";
	public static String CORE_FONT="font";
	public static String CORE_ECHO_OUTPUT="String Typed: ";
	public static String CORE_QUIT="quit";
	public static String CORE_COLORC="color";
	public static String CORE_MATRIX="matrix";
	public static String CORE_DRAWC="draw";
	public static int CORE_DATA_ILENGTH=10;
	public static int CORE_DATA_INCR=1;
	public static int CORE_FILTER_BUFFER=32;
	public static String CORE_FILTER_IOSYSERR="Syntax Error On File";
	public static String CORE_DATA_TYPEERR="Unknow Data Type";
	public static int CORE_DATA_TYPESNUM=2;
	public static int CORE_DATA_NOTYPE=0;
	public static int CORE_DATA_TEXTTYPE=1;
	public static int CORE_DATA_POINTTYPE=2;
	public static String CORE_DATA_DIFFTYPEERR="Internal Data Error";
	public static String CORE_READER_TEXTSEP="\n";
	public static String CORE_READER_IOERR="IO Error";
	public static int CORE_DRAW_INITCAP=4;
	public static int CORE_DRAW_INCR=1;
	public static int CORE_DRAW_LINETYPE=1;
	public static int CORE_DRAW_CUBICLINE=3;
	public static int CORE_DRAW_LINKINITCAP=3;
	public static int CORE_DRAW_LINKINCR=1;
	public static String CORE_DRAW_NOTYPEERR="Arc Type Error";
	public static String CORE_DRAW_INERR="Vertex Already In";
	public static String CORE_DRAW_NOINERR="Vertex Not In";
	public static String CORE_DRAW_NODRAW="Draw Does Not Exist";
	public static String CORE_OBJ_INPUTPANEL="console";
	public static String CORE_OBJ_BG="background";
	public static String CORE_OBJ_FG="foreground";
	public static String CORE_OBJ_COLORPANEL="color";
	public static Color CORE_COLORCANVAS_BORDER=Color.white;
	public static int FBYTENUM=1; 
	public static int DBYTENUM=2; 
	public static int NBYTENUM=-1;
	public static String MATRIX_ROW="Row";
	public static String MATRIX_COLUMN="Column";
	public static int DRAWAID_INITCAP=4;
	public static int DRAWAID_INCR=1;
	public static Color DRAWCANVAS_BORDERCOLOR=Color.black;
	public static Color DRAWBERZIE_HULLCOLOR=Color.darkGray;
	public static int DRAWCANVAS_INTICAP=4;
	public static int DRAWCANVAS_INCR=4;
	public static int DRAWGRID_SUBDIVISION=9;
	public static double DRAWGRID_STARTX=-2.0;
	public static double DRAWGRID_STARTY=-2.0;
	public static double DRAWGRID_ENDX=2.0;
	public static double DRAWGRID_ENDY=2.0;
	public static double DRAWGRID_Z=0.0;
	public static Color DRAWGRID_COLOR=Color.lightGray;
	public static double DRAWAXIS_UNIT=1.0;
	public static Color DRAWAXIS_COLOR=Color.red;
	public static double DRAWCUBE_UNIT=1.0;
	public static Color DRAWCUBE_COLOR=Color.blue;
	public static Color DRAWBERZIE_COLOR=Color.blue;
	public static double DRAWADAPTER_SCALE=0.05;
	public static double DRAWADAPTER_ROTATEX=0.05;
	public static double DRAWADAPTER_ROTATEY=0.05;
	public static double DRAWCANVAS_CAMERADIST=0.1;
	public static double DRAWCANVAS_MINDIST=0.1;
	public static double DRAWCANVAS_NAMEY=0.5;
	public static double DRAWCANVAS_NAMEX=0.5;

	public static double DRAWCANVAS_MAXDISTANCE=5;
	public static int DRAWCANVAS_MAXRESERVED=2;
	public static Color ENGINE_SELECTEDCOLOR=Color.red;
	public static String X="x";
	public static String Y="y";
	public static String Z="z";
	public static int ENGINE_INITCAP=4;
	public static int ENGINE_INCR=1;
	public static int ENGINE_EYE=1;
	public static int ENGINE_TOP=2;
	public static int ENGINE_SIDE=3;
	public static int ENGINE_FRONT=4;
	public static int DRAWCANVAS_NOFLYP=-1;
	public static int DRAWCANVAS_RTSTYPE=1;	
	public static int DRAWCANVAS_SRTTYPE=3;
	public static int DRAWCANVAS_TRSTYPE=4;	
	public static int DRAWCANVAS_STRTYPE=6;
	public static int DRAWCANVAS_TRTYPE=7;
	public static int DRAWCANVAS_RTTYPE=8;
	public static int DRAWCANVAS_TTYPE=9;
	public static int DRAWCANVAS_RTYPE=10;
	public static int DRAWCANVAS_HASMODIFIED=1;
	
	public static Color DRAWSPHERE_COLOR=Color.green;
	public static int DRAWSPHERE_SECTIONS=8;
	public static int DRAWSPHERE_HEIGHTCIRCLES=8;
	public static double DRAWSPHERE_RADIUS=1.0;
	public static int DRAWCANVAS_POLY=0;
	public static int DRAWCANVAS_BERZIE=1;
	public static int DRAWCANVAS_RATIONAL=2;
	public static int DRAWCANVAS_BERZIEUSECT=8;
	public static int DRAWCANVAS_BERZIEVSECT=8;
	public static double DRAWBERZIE_Z=0.0;
	public static double DRAWBERZIE_UNIT=2.0;
	public static double DRAWRATIONALBERZIE_INITWEIGHT=1.0;
	public static int DRAWBERZIE_DEGREEV=3;
	public static int DRAWBERZIE_DEGREEU=3;
	public static int COLLISIONENGINE_BOUNDINGSPHERE=1;
	public static int COLLISIONENGINE_BOUNDINGBOX=2;
	public static int COLLISIONENGINE_BYITERATION=3;
	public static int COLLISIONENGINE_ANALITYC=4;
	public static int COLLISIONENGINE_COLLISIONSPHERE=8;
	public static Color COLLISIONENGINE_COLOR=Color.magenta;
	public static int COLLISIONENGINE_COLLISIONSPHERECIRCLESNUMBER=5;
	public static double COLLISIONENGINE_ZERO=Double.MIN_VALUE;
	public static double COLLISIONENGINE_NZERO=0.00000001;
}