import java.util.Vector;
import java.awt.Color;

public class Draw {

Vector vertex;
int continuity;
Color color;
int type;
double[] rotate={0,0,0},translate={0,0,0},scale={1,1,1,1};
public boolean isReal=true;


	public Draw(int continuity) {

		vertex=new Vector(CoreConstant.CORE_DRAW_INITCAP,CoreConstant.CORE_DRAW_INCR);
		this.continuity=continuity;
	}
	
	public Draw() {
		
		vertex=new Vector(CoreConstant.CORE_DRAW_INITCAP,CoreConstant.CORE_DRAW_INCR);
	}	
	
	public void setColor(Color color) {
	
		this.color=color;
	}
	
	public Color getColor() {
	
		return color;
	}
	
	public void addVertex(double[] point) {
	
	DrawElement element;	
	boolean flag;
		
		flag=true;
		if (!vertex.isEmpty()) {
			for(int i=0;i<vertex.size();i++) {
				element=(DrawElement)vertex.get(i);
				if (element.getVertex()==point) {
					flag=false;
					break;
				}
			}
		}
		if(flag)
			this.vertex.add(new DrawElement(point));
	}	

	public void addNeighbours(double[] point,int[] vertex) {
	
	DrawElement element;	
	boolean flag;
		
		flag=false;
		for(int i=0;i<this.vertex.size();i++) {
			element=(DrawElement)this.vertex.get(i);
			if (Geometry.isEqual(element.getVertex(),point)) {
				element.setNeighbours(vertex);
				break;
			}
		}
	}

	public String getName(double[] point) {
	
	DrawElement element;	
		
		if (!vertex.isEmpty())
			for(int i=0;i<vertex.size();i++) {
				element=(DrawElement)vertex.get(i);
				if (element.getVertex()==point)
					return(element.getName());
			}
		return null;
	}

	public String getName(int position) {
	
		if (position<vertex.size())
			return(((DrawElement)vertex.get(position)).getName());
		return null;
	}
	
	public void addElement(double[] point,int[] vertex) {
	
	DrawElement element;	
	boolean flag;
		
		flag=true;
		for(int i=0;i<this.vertex.size();i++) {
			element=(DrawElement)this.vertex.get(i);
			if (element.getVertex()==point) {
				flag=false;
				break;
			}
		}
		if(flag)
			this.vertex.add(new DrawElement(point,vertex));
	}	

	public void addElement(double[] point,int[] vertex,String name) {
	
	DrawElement element;	
	boolean flag;
		
		flag=true;
		for(int i=0;i<this.vertex.size();i++) {
			element=(DrawElement)this.vertex.get(i);
			if (element.getVertex()==point) {
				flag=false;
				break;
			}
		}
		if(flag)
			this.vertex.add(new DrawElement(point,vertex,name));
	}

	public double[][] getVertex() {
	
	double[][] returnValue=new double[vertex.size()][];	
	
		for(int i=0;i<vertex.size();i++) {
			returnValue[i]=((DrawElement)vertex.get(i)).getVertex();
		}
		return returnValue;
	}
	
	public double[] getVertex(int position) {
	
		if(position<vertex.size())
			return (double[])((((DrawElement)vertex.get(position)).getVertex()).clone());
		return null;
	}
	
	public void setVertex(int position,double[] point) {
	
//		for(int i=0;i<point.length;i++)
//			System.out.println("point " +point[i]);
		if(position<vertex.size())
			((DrawElement)vertex.get(position)).setVertex(point);
		Engine.removeNotReal();
	}
	
	public int[] getNeighbours(double[] point) {
	
	int[] returnValue=null;
	DrawElement element;			

		for(int i=0;i<vertex.size();i++) {
			element=(DrawElement)this.vertex.get(i);		
			if (element.getVertex()==point) {
					returnValue=element.getNeighbours();
					break;
			}
		}
		return returnValue;
	}
	
	public int[] getNeighbours(int position) {
	
	int[] returnValue=null;

		if (position<vertex.size()) 
			returnValue=((DrawElement)vertex.get(position)).getNeighbours();
		return returnValue;
	}
	
//	public void remove(int position) {
//	int[] neighbour;
//	
//		if(position<vertex.size()) {
//			neighbour=((DrawElement)vertex.get(position)).getNeighbours();
//			for(int i=0;
//		}
//	}	
	
	public int size() {
	
		return vertex.size();
	}
	
	public double[] getRotate() {
	
		return rotate;
	}

	public void setRotate(double[] rotate) {
	
		this.rotate=rotate;
//		Engine.removeNotReal();
	}

	public double[] getTranslate() {
	
		return translate;
	}

	public void setTranslate(double[] translate) {
	
		this.translate=translate;
//		Engine.removeNotReal();
	}

	public double[] getScale() {
	
		return scale;
	}

	public void setScale(double[] scale) {
	
		this.scale=scale;
//		Engine.removeNotReal();
	}
	
	public boolean checkDraw2D(int[] position) {
	
	double[] point=new double[position.length];
//	boolean[] condition=new boolean[4];
//	
//		for(int i=0;i<vertex.size();i++) {
//			point=getVertex(i);
//			if(point[0]<position[0] && point[1]<position[1] && !condition[0])
//				condition[0]=true;
//			if(point[0]<position[0] && point[1]>position[1] && !condition[1])
//				condition[1]=true;
//			if(point[0]>position[0] && point[1]<position[1] && !condition[2])
//				condition[2]=true;
//			if(point[0]>position[0] && point[1]>position[1] && !condition[3])				
//				condition[3]=true;
//		}
//		double[] position1=new double[position.length];
		for(int i=0;i<position.length;i++)
			point[i]=(double)position[i];
//		this.isIn(position1);
//		return(condition[0] && condition[1] && condition[2] && condition[3]);
		return(isIn(point));
	}
	
	public int getType() {
	
		return this.type;
	}

	public void setType(int type) {
	
		this.type=type;
	}

	public double[] getPoint(double u,double v,Draw draw) {
	
		return null;
	}

		public int getDegreeX() {
	
		return -1;
	}

	public int getDegreeY() {
	
		return -1;
	}
	
	public Matrix getWeights() {
	
		return null;
	}
	
	public void setWeights(Matrix weights) {
	
	}

	public boolean isIn(double[] position) {

	int[] perimeter=this.calculatePerimeter();
	double[] tmpVertex,vertex1,vertex2,baricenter=getBaricenter();
	int length=0;
	double a=0.0,b=0.0,c=0.0;
	

		
		
		for(int i=0;i<perimeter.length-1 && perimeter[i+1]!=-1;i++){
			vertex1=getVertex(perimeter[i]);
			vertex2=getVertex(perimeter[i+1]);
			a=vertex1[1]-vertex2[1];
			b=vertex2[0]-vertex1[0];
			c=vertex1[0]*vertex2[1]-vertex1[1]*vertex2[0];
			if(!((baricenter[0]*a+baricenter[1]*b+c)*(position[0]*a+position[1]*b+c)>0))
				return false;
			length=i+1;
			}
		vertex1=getVertex(perimeter[0]);
		vertex2=getVertex(perimeter[length-1]);
		a=vertex1[1]-vertex2[1];
		b=vertex2[0]-vertex1[0];
		c=vertex1[0]*vertex2[1]-vertex1[1]*vertex2[0];
		if(!((baricenter[0]*a+baricenter[1]*b+c)*(position[0]*a+position[1]*b+c)>0))
			return false;
		return true;
	}
	
	protected double[] getBaricenter() {
		
		double[] tmpVertex,returnValue=new double[4];
		for(int i=0;i<vertex.size();i++) {
			tmpVertex=((DrawElement)vertex.get(i)).getVertex();
			for(int j=0;j<tmpVertex.length;j++)
				returnValue[j]+=tmpVertex[j]/vertex.size();
		}
//		System.out.println("baricenter "+ returnValue[0] +" "+ returnValue[1]);
		return returnValue;
	}
	
	protected int findNearestVertex(double[] position) {

		double[] tmpVertex;
		double distance,min=Double.POSITIVE_INFINITY;
		int returnValue=-1;
		
		for(int i=0;i<vertex.size();i++) {
			tmpVertex=((DrawElement)vertex.get(i)).getVertex();
			distance=Math.pow(position[0]-tmpVertex[0],2.0)+Math.pow(position[1]-tmpVertex[1],2.0);
//			System.out.println("vertex " + i +" distance " +distance);
			if(distance<min) {
				min=distance;
				returnValue=i;
			}
		}
		System.out.println("ret "+ returnValue);
		return returnValue;
	}

	protected int findFarestVertex(double[] position) {

		double[] tmpVertex;
		double distance,max=0;
		int returnValue=-1;
		
		for(int i=0;i<vertex.size();i++) {
			tmpVertex=((DrawElement)vertex.get(i)).getVertex();
			distance=Math.pow(position[0]-tmpVertex[0],2.0)+Math.pow(position[1]-tmpVertex[1],2.0);
//			System.out.println("vertex " + i +" distance " +distance);
			if(distance>max) {
				max=distance;
				returnValue=i;
			}
		}
//		System.out.println("ret "+ returnValue);
		return returnValue;
	}
							 
	protected double calculateIntersection(double[] p1,double[] p2,double[] q1,double[] q2) {
		
		double t[]=new double[p1.length];
		t[0]=(q2[0]-p2[0])/(p1[0]-q1[0]-p2[0]-q2[0]);
		t[1]=(q2[1]-p2[1])/(p1[1]-q1[1]-p2[1]-q2[1]);
		if(t[0]!=t[1])
			return Double.NaN;
		else if(t[0]<0 || t[1]>1)
			return Double.NaN;
		else 
			return t[0];
	}
	
	protected int[] calculatePerimeter() {
//		
//		double[] tmpValue=null,baricenter=getBaricenter();
//		int[] returnValue=new int[vertex.size()];
//		int[] neighbour;
//		double distance,max=0;
//		int nextVertex=-2,count=1;
//		boolean flag=true;		
//
//		neighbour=((DrawElement)vertex.get(returnValue[0])).getNeighbours();
//		for(int i=0;i<returnValue.length;i++)
//			returnValue[i]=-1;
//		returnValue[0]=findFarestVertex(baricenter);
//		System.out.println("first " +returnValue[count-1]);
//		while(flag) {
//			max=0;
//			System.out.println("first " +returnValue[count-1]);
//			neighbour=((DrawElement)vertex.get(returnValue[count-1])).getNeighbours();
//			for(int i=0;i<neighbour.length;i++) {
//				tmpValue=((DrawElement)vertex.get(neighbour[i])).getVertex();// errore
//				distance=distance(tmpValue,baricenter);
//				for(int k=0;k<tmpValue.length;k++) {
//					System.out.println("value " +k+" : "+tmpValue[k]);
//				}
//				System.out.println(i + " parent "+ returnValue[count-1]+" neig "+ neighbour[i] );
//				if(flag && differ(neighbour[i],returnValue[count-1]) && notAlreadyIn(neighbour[i],returnValue) && distance>max){
//					System.out.println("kkkkkkk");
//					max=distance;
//					nextVertex=neighbour[i];
//				}
//				if(neighbour[i]==returnValue[0] && count>2) {
//					flag=false;
//					nextVertex=-1;
//				}
//			}
//			System.out.println("next " + returnValue[count-1]);
//			returnValue[count++]=nextVertex;
//		}
//		return returnValue;

		int[] returnValue=new int[vertex.size()];
		int[] path=new int[vertex.size()];
		int[] neighbour;
		double cos;
		boolean isin;
		double[] tmpVertex;
		double[] baricenter=getBaricenter();
		double distance,max=0,min=2.0;
		int nextVertex=-1;
		int count=2;
		
		for(int i=0;i<returnValue.length;i++) {
			returnValue[i]=-1;
			path[i]=-1;
		}
		path[1]=findFarestVertex(baricenter);
		neighbour=getNeighbours(path[1]);
		for(int i=0;i<neighbour.length;i++)  {
			for(int j=i+1;j<neighbour.length;j++) {
				cos=calculateCos(neighbour[i],path[1],neighbour[j]);
				if(cos<min) {
					min=cos;
					path[0]=neighbour[i];
					path[2]=neighbour[j];
				}
			}
		}
		if(path[0]==-1){
			neighbour=getNeighbours(path[1]);
			path[0]=neighbour[0];
			path[2]=neighbour[1];
			return path;
		}
//		System.out.println("path " +path[0]);
//		System.out.println("path " +path[1]);
//		System.out.println("path " +path[2]);
		while(path[0]!=path[count]) {
			min=2.0;
//			for(int d=0;d<path.length;d++)
//				System.out.println("num "+count+" path["+d+"] " +path[d]);
			neighbour=((DrawElement)vertex.get(path[count])).getNeighbours();
			for(int i=0;i<neighbour.length;i++) {
				if(neighbour[i]!=path[count-1] && differ(neighbour[i],path[count])) {
					tmpVertex=((DrawElement)vertex.get(neighbour[i])).getVertex();
					cos=calculateCos(path[count-1],path[count],neighbour[i]);
					if(cos<min) {
//						System.out.println("kkkkkkk");
						min=cos;
						nextVertex=neighbour[i];
					}
				}
			}
//			System.out.println("path " +path[count]);
//			for(int d=0;d<path.length;d++)
//				System.out.println("num "+count+" path["+d+"] " +path[d]);
//			System.out.println("nextVertex " + nextVertex);
			if(AlreadyIn(nextVertex,path) &&  nextVertex!=path[0]) {
				path[++count]=nextVertex;
//				System.out.println("warning on perimeter");
//				for(int d=0;d<path.length;d++)
//					System.out.println("path["+d+"] " +path[d]);
				return path;
			}
			if(nextVertex!=-1 && count<path.length)
				path[++count]=nextVertex;
			else
				return path; // warning

//			System.out.println("path " +path[count]);
		}
//		for(int d=0;d<path.length;d++)
//			System.out.println("num"+count+"path["+d+"] " +path[d]);
		return path;
	}
	
	protected double distance(double[] p1,double[] p2) {
		double distance=Math.pow(p1[0]-p2[0],2.0)+Math.pow(p1[1]-p2[1],2.0);
		return distance;
	}
	
	protected boolean differ(int i,int j) {
		double[] p1,p2;
		
		p1=((DrawElement)vertex.get(i)).getVertex();
		p2=((DrawElement)vertex.get(j)).getVertex();
		for(int k=0;k<p1.length;k++)
			if(p1[k]!=p2[k]) 
				return true;
		return false;
	}
	
	protected boolean AlreadyIn(int position,int[] check) {
		
		for(int i=0;i<check.length && check[i]!=-1;i++)
			if(check[i]==position)
				return true;
		return false;
	}
	
	public double calculateCos(int i,int j,int k) {
		
		double[] p1,p2,p3,vector1,vector2;
		double numerator=0,denominator;
		
		
		p1=((DrawElement)vertex.get(i)).getVertex();
		p2=((DrawElement)vertex.get(j)).getVertex();
		p3=((DrawElement)vertex.get(k)).getVertex();
		vector1=new double[p1.length];
		vector2=new double[p2.length];
		for(int m=0;m<2;m++) {
			vector1[m]=p1[m]-p2[m];
			vector2[m]=p3[m]-p2[m];
		}
//		for(int m=0;m<2;m++) {
//			System.out.println("vector1 x " +vector1[m]+ "=" +p1[m]+"-"+p2[m]+"vector2 x " +vector2[m]+ "=" +p2[m]+"-"+p3[m]);
//		}
		for(int m=0;m<2;m++) {
			numerator=numerator+vector1[m]*vector2[m];
		}
		denominator=Math.sqrt(Math.pow(vector1[0],2.0)+Math.pow(vector1[1],2.0))*Math.sqrt(Math.pow(vector2[0],2.0)+Math.pow(vector2[1],2.0));
//		System.out.println("result for "+i+" "+j+" "+k+" : " +numerator/denominator);
		return numerator/denominator;
	}
	
	public void makeOmogeneous() {
		double[] tmpVertex;
		
		for(int i=0;i<vertex.size();i++) {
			tmpVertex=this.getVertex(i);
//			for(int k=0;k<tmpVertex.length;k++)
//				System.out.println("first x[" +k+"] " +tmpVertex[k]);
			tmpVertex=Geometry.makeOmogenous(tmpVertex);
//			for(int k=0;k<tmpVertex.length;k++)
//				System.out.println("after x[" +k+"] " +tmpVertex[k]);
			this.setVertex(i,tmpVertex);
//			tmpVertex=this.getVertex(i);
//			for(int k=0;k<tmpVertex.length;k++)
//				System.out.println("in x[" +k+"] " +tmpVertex[k]);
		}
	}
	
	public String toString() {
	double[] tmp;
	int[] neighbour;
	String returnValue="";
		
		for(int i=0;i<vertex.size();i++) {
			tmp=getVertex(i);
			neighbour=getNeighbours(i);
			returnValue+="i: "+i;
			for(int j=0;j<tmp.length;j++)
				returnValue+=" point["+j+"]: "+tmp[j];
			returnValue+=" neighbour ";
			if(neighbour!=null)
				for(int j=0;j<neighbour.length;j++)
					returnValue+=" "+neighbour[j];
			else
				returnValue+=" no ";
			returnValue+="\n";
		}
		return returnValue;
	}
	
}