public class DrawCube extends Draw {


	public DrawCube() {
	
	double[] point=new double[4];
	int[] neighbour=new int[3];

		point[0]=CoreConstant.DRAWCUBE_UNIT;
		point[1]=CoreConstant.DRAWCUBE_UNIT;
		point[2]=CoreConstant.DRAWCUBE_UNIT;	
		point[3]=1.0;
		neighbour[0]=1;	
		neighbour[1]=3;
		neighbour[2]=4;
		vertex.add(new DrawElement((double[])point.clone(),(int[])neighbour.clone()));
		point[0]=-CoreConstant.DRAWCUBE_UNIT;
		point[1]=CoreConstant.DRAWCUBE_UNIT;
		point[2]=CoreConstant.DRAWCUBE_UNIT;	
		point[3]=1.0;
		neighbour[0]=0;	
		neighbour[1]=2;
		neighbour[2]=5;
		vertex.add(new DrawElement((double[])point.clone(),(int[])neighbour.clone()));
		point[0]=-CoreConstant.DRAWCUBE_UNIT;
		point[1]=-CoreConstant.DRAWCUBE_UNIT;
		point[2]=CoreConstant.DRAWCUBE_UNIT;	
		point[3]=1.0;
		neighbour[0]=1;	
		neighbour[1]=3;
		neighbour[2]=6;
		vertex.add(new DrawElement((double[])point.clone(),(int[])neighbour.clone()));
		point[0]=CoreConstant.DRAWCUBE_UNIT;
		point[1]=-CoreConstant.DRAWCUBE_UNIT;
		point[2]=CoreConstant.DRAWCUBE_UNIT;	
		point[3]=1.0;
		neighbour[0]=2;	
		neighbour[1]=0;
		neighbour[2]=7;
		vertex.add(new DrawElement((double[])point.clone(),(int[])neighbour.clone()));
		point[0]=CoreConstant.DRAWCUBE_UNIT;
		point[1]=CoreConstant.DRAWCUBE_UNIT;
		point[2]=-CoreConstant.DRAWCUBE_UNIT;	
		point[3]=1.0;
		neighbour[0]=0;	
		neighbour[1]=5;
		neighbour[2]=7;
		vertex.add(new DrawElement((double[])point.clone(),(int[])neighbour.clone()));
		point[0]=-CoreConstant.DRAWCUBE_UNIT;
		point[1]=CoreConstant.DRAWCUBE_UNIT;
		point[2]=-CoreConstant.DRAWCUBE_UNIT;	
		point[3]=1.0;
		neighbour[0]=1;	
		neighbour[1]=6;
		neighbour[2]=4;
		vertex.add(new DrawElement((double[])point.clone(),(int[])neighbour.clone()));
		point[0]=-CoreConstant.DRAWCUBE_UNIT;
		point[1]=-CoreConstant.DRAWCUBE_UNIT;
		point[2]=-CoreConstant.DRAWCUBE_UNIT;	
		point[3]=1.0;
		neighbour[0]=2;	
		neighbour[1]=5;
		neighbour[2]=7;
		vertex.add(new DrawElement((double[])point.clone(),(int[])neighbour.clone()));
		point[0]=CoreConstant.DRAWCUBE_UNIT;
		point[1]=-CoreConstant.DRAWCUBE_UNIT;
		point[2]=-CoreConstant.DRAWCUBE_UNIT;	
		point[3]=1.0;
		neighbour[0]=3;	
		neighbour[1]=6;
		neighbour[2]=4;
		vertex.add(new DrawElement((double[])point.clone(),(int[])neighbour.clone()));
		setColor(CoreConstant.DRAWCUBE_COLOR);
	}
	
	public DrawCube(int unit) {
	
	double[] point=new double[4];
	int[] neighbour=new int[3];

		point[0]=unit;
		point[1]=unit;
		point[2]=unit;	
		point[3]=1.0;
		neighbour[0]=1;	
		neighbour[1]=3;
		neighbour[2]=4;
		vertex.add(new DrawElement((double[])point.clone(),(int[])neighbour.clone()));
		point[0]=-unit;
		point[1]=unit;
		point[2]=unit;	
		point[3]=1.0;
		neighbour[0]=0;	
		neighbour[1]=2;
		neighbour[2]=5;
		vertex.add(new DrawElement((double[])point.clone(),(int[])neighbour.clone()));
		point[0]=-unit;
		point[1]=-unit;
		point[2]=unit;	
		point[3]=1.0;
		neighbour[0]=1;	
		neighbour[1]=3;
		neighbour[2]=6;
		vertex.add(new DrawElement((double[])point.clone(),(int[])neighbour.clone()));
		point[0]=unit;
		point[1]=-unit;
		point[2]=unit;	
		point[3]=1.0;
		neighbour[0]=2;	
		neighbour[1]=0;
		neighbour[2]=7;
		vertex.add(new DrawElement((double[])point.clone(),(int[])neighbour.clone()));
		point[0]=unit;
		point[1]=unit;
		point[2]=-unit;	
		point[3]=1.0;
		neighbour[0]=0;	
		neighbour[1]=5;
		neighbour[2]=7;
		vertex.add(new DrawElement((double[])point.clone(),(int[])neighbour.clone()));
		point[0]=-unit;
		point[1]=unit;
		point[2]=-unit;	
		point[3]=1.0;
		neighbour[0]=1;	
		neighbour[1]=6;
		neighbour[2]=4;
		vertex.add(new DrawElement((double[])point.clone(),(int[])neighbour.clone()));
		point[0]=-unit;
		point[1]=-unit;
		point[2]=-unit;	
		point[3]=1.0;
		neighbour[0]=2;	
		neighbour[1]=5;
		neighbour[2]=7;
		vertex.add(new DrawElement((double[])point.clone(),(int[])neighbour.clone()));
		point[0]=unit;
		point[1]=-unit;
		point[2]=-unit;	
		point[3]=1.0;
		neighbour[0]=3;	
		neighbour[1]=6;
		neighbour[2]=4;
		vertex.add(new DrawElement((double[])point.clone(),(int[])neighbour.clone()));
		setColor(CoreConstant.DRAWCUBE_COLOR);
	}
}