import java.util.Vector;

public class DrawElement extends Object {

	double[] vertex;
	int[] connectedTo;
	String vertexName;
	
	DrawElement(double[] vertex,int[] connectedTo,String name) {
	
		this.vertex=vertex;
		this.connectedTo=connectedTo;
		vertexName=name;
	}

	
	DrawElement(double[] vertex,int[] connectedTo) {
	
		this.vertex=vertex;
		this.connectedTo=connectedTo;
		vertexName=null;
	}
	
	DrawElement() {
	
		this.vertex=new double[4];
	}
	
	DrawElement(double[] vertex) {
	
		this.vertex=vertex;
	}


	public void setName(String name) {
	
		this.vertexName=name;
	}
	
	public String getName() {
	
		return(vertexName);
	}
	
	public void setVertex(double[] vertex) {
	
		this.vertex=vertex;
	}
	
	public double[] getVertex() {
	
		return(vertex);
	}
	
	public void setNeighbours(int[] neighbours) {
	
		for(int i=0;i<neighbours.length;i++)
//		System.out.println("neighbours "+i+" "+neighbours[i]); 
		this.connectedTo=neighbours;
	}
	
	public int[] getNeighbours() {
	
		return connectedTo;
	}
}