import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class DrawFrameAdapter implements ActionListener {

static int id,subid;
static boolean oneTime=true;

	DrawFrameAdapter() {
		
		
	}
	
	public void actionPerformed(ActionEvent evt) {
		id=0;
		if(evt.getActionCommand()==Constant.DRAWPANEL_CUBE) {
			id=1;
			String[] parameters= {Constant.DRAWFRAMEADAPTER_EDGE};
			double[] values= {CoreConstant.DRAWCUBE_UNIT};
			ParameterFrame.getParameter(parameters,values);
		}else if(evt.getActionCommand()==Constant.DRAWPANEL_SPHERE) {
			id=2;
			String[] parameters= {Constant.DRAWFRAMEADAPTER_RADIUS,Constant.DRAWFRAMEADAPTER_SECTIONS,Constant.DRAWFRAMEADAPTER_HEIGHTCIRCLES};
			double[] values= {CoreConstant.DRAWSPHERE_RADIUS,CoreConstant.DRAWSPHERE_SECTIONS,CoreConstant.DRAWSPHERE_HEIGHTCIRCLES};
			ParameterFrame.getParameter(parameters,values);
		}else if(evt.getActionCommand()==Constant.DRAWPANEL_BERZIE) {
			id=3;
			String[] parameters= {Constant.DRAWFRAMEADAPTER_UNIT,Constant.DRAWFRAMEADAPTER_Z,Constant.DRAWFRAMEADAPTER_DEGREEU,Constant.DRAWFRAMEADAPTER_DEGREEV};
			double[] values= {CoreConstant.DRAWBERZIE_UNIT,CoreConstant.DRAWBERZIE_Z,CoreConstant.DRAWBERZIE_DEGREEU,CoreConstant.DRAWBERZIE_DEGREEV};
			ParameterFrame.getParameter(parameters,values);
		}else if(evt.getActionCommand()==Constant.DRAWPANEL_RATIONALBERZIE) {
			id=4;
			String[] parameters= {Constant.DRAWFRAMEADAPTER_UNIT,Constant.DRAWFRAMEADAPTER_Z,Constant.DRAWFRAMEADAPTER_DEGREEU,Constant.DRAWFRAMEADAPTER_DEGREEV};
			double[] values= {CoreConstant.DRAWBERZIE_UNIT,CoreConstant.DRAWBERZIE_Z,CoreConstant.DRAWBERZIE_DEGREEU,CoreConstant.DRAWBERZIE_DEGREEV};
			ParameterFrame.getParameter(parameters,values);
		}else if(evt.getActionCommand()==Constant.DRAWFRAME_TRANSLATE) {
			id=5;
			if(DrawPanel.objectCheckbox.getState()==true) {
				subid=1;
				String[] parameters= {Constant.DRAWFRAMEADAPTER_X,Constant.DRAWFRAMEADAPTER_Y,Constant.DRAWFRAMEADAPTER_Z};
				double[] values=Engine.getDrawTranslate();
				ParameterFrame.getParameter(parameters,values);
			}else if(DrawPanel.vertexCheckbox.getState()==true) {
				subid=2;
				String[] parameters= {Constant.DRAWFRAMEADAPTER_X,Constant.DRAWFRAMEADAPTER_Y,Constant.DRAWFRAMEADAPTER_Z};
				double[] values=Engine.getSelectedVertex();
				ParameterFrame.getParameter(parameters,values);
			}
		}else if(evt.getActionCommand()==Constant.DRAWFRAME_ROTATE) {
			id=6;
			String[] parameters= {Constant.DRAWFRAMEADAPTER_X,Constant.DRAWFRAMEADAPTER_Y,Constant.DRAWFRAMEADAPTER_Z};
			double[] values=Engine.getDrawRotate();
			ParameterFrame.getParameter(parameters,values);
		}else if(evt.getActionCommand()==Constant.DRAWFRAME_SCALE) {
			id=7;
			String[] parameters= {Constant.DRAWFRAMEADAPTER_X,Constant.DRAWFRAMEADAPTER_Y,Constant.DRAWFRAMEADAPTER_Z,Constant.DRAWFRAMEADAPTER_U};
			double[] values=Engine.getDrawScale();
//			System.out.println("lenght " + values.length);
			ParameterFrame.getParameter(parameters,values);
		}else if(evt.getActionCommand()==Constant.DRAWFRAME_SETCOLOR) {
			id=8;
			ColorFrame.on();
		}else if(evt.getActionCommand()==Constant.DRAWPANEL_BYOBJECT) {
			id=9;
			Engine.select(-1);
			Engine.selectVertex(-1);
			Engine.setSelectedWeight(-1);
			DrawPanel.objectCheckbox.setState(true);
			boolean[] menu=new boolean[DrawFrame.menunum];
			menu[0]=true;
			menu[1]=true;
			menu[2]=true;
			menu[3]=true;
			menu[4]=true;
			menu[5]=true;
			menu[6]=true;
			menu[7]=true;
			menu[8]=true;
			menu[9]=true;
			menu[10]=true;
			menu[11]=true;
			menu[12]=true;
			DrawFrame.setMenu(menu);
		}else if(evt.getActionCommand()==Constant.DRAWPANEL_BYVERTEX) {
			Engine.select(-1);
			Engine.selectVertex(-1);
			Engine.setSelectedWeight(-1);
			id=10;
			DrawPanel.vertexCheckbox.setState(true);
			boolean[] menu=new boolean[DrawFrame.menunum];
			menu[0]=true;
			menu[1]=true;
			menu[2]=true;
			menu[3]=true;
			menu[4]=true;
			menu[5]=false;
			menu[6]=false;
			menu[7]=true;
			menu[8]=true;
			menu[9]=true;
			menu[10]=true;
			menu[11]=true;
			menu[12]=true;
			DrawFrame.setMenu(menu);
		}else if(evt.getActionCommand()==Constant.DRAWPANEL_BYWEIGHT) {
			Engine.select(-1);
			Engine.selectVertex(-1);
			Engine.setSelectedWeight(-1);
			id=11;
			DrawPanel.weightsCheckbox.setState(true);
			boolean[] menu=new boolean[DrawFrame.menunum];
			menu[0]=true;
			menu[1]=true;
			menu[2]=true;
			menu[3]=true;
			menu[4]=true;
			menu[5]=false;
			menu[6]=false;
			menu[7]=true;
			menu[8]=true;
			menu[9]=true;
			menu[10]=true;
			menu[11]=true;
			menu[12]=true;
			DrawFrame.setMenu(menu);			
		}else if(evt.getActionCommand()==Constant.DRAWFRAME_SPANU) {
			id=12;
			String[] parameters= {Constant.DRAWFRAME_SPANU};
			double[] values= {CoreConstant.DRAWCANVAS_BERZIEUSECT};
			ParameterFrame.getParameter(parameters,values);
		}else if(evt.getActionCommand()==Constant.DRAWFRAME_SPANV) {
			id=13;
			String[] parameters= {Constant.DRAWFRAME_SPANV};
			double[] values= {CoreConstant.DRAWCANVAS_BERZIEVSECT};
			ParameterFrame.getParameter(parameters,values);
		}else if(evt.getActionCommand()==Constant.DRAWFRAME_SIDEDISTANCE) {
			id=14;
			String[] parameters= {Constant.DRAWFRAME_SIDEDISTANCE};
			double[] values=new double[1];
			values[0]=Engine.getSideDistance();
			ParameterFrame.getParameter(parameters,values);
		}else if(evt.getActionCommand()==Constant.DRAWFRAME_FRONTDISTANCE) {
			id=15;
			String[] parameters= {Constant.DRAWFRAME_FRONTDISTANCE};
			double[] values=new double[1];
			values[0]=Engine.getFrontDistance();
			ParameterFrame.getParameter(parameters,values);
		}else if(evt.getActionCommand()==Constant.DRAWFRAME_TOPDISTANCE) {
			id=16;
			String[] parameters= {Constant.DRAWFRAME_TOPDISTANCE};
			double[] values=new double[1];
			values[0]=Engine.getTopDistance();
			ParameterFrame.getParameter(parameters,values);
		}else if(evt.getActionCommand()==Constant.DRAWFRAME_EYEDISTANCE) {
			id=17;
			String[] parameters= {Constant.DRAWFRAME_EYEDISTANCE};
			double[] values=new double[1];
			values[0]=Engine.getEye()[0];
			ParameterFrame.getParameter(parameters,values);
		}else if(evt.getActionCommand()==Constant.DRAWFRAME_PLANEDISTANCE) {
			id=18;
			String[] parameters= {Constant.DRAWFRAME_PLANEDISTANCE};
			double[] values=new double[1];
			values[0]=Engine.getDistance();
			ParameterFrame.getParameter(parameters,values);
		}

	}
	
	public static void restart() {
	
	double[] parameters=null,tmpValue;
		
		if(oneTime) {
			if(id==0) {

			}else{
				if(id!=8)
					parameters=ParameterPanel.returnValues();
				if(id==1) {
					Engine.addDraw(new DrawCube((int)parameters[0]));
					DrawFrame.redraw();
				}else if(id==2) {
					Engine.addDraw(new DrawSphere(parameters[0],(int)parameters[1],(int)parameters[2]));
					DrawFrame.redraw();
				}else if(id==3) {
					Engine.addDraw(new DrawBerzie((int)parameters[0],parameters[1],(int)parameters[2],(int)parameters[3]));
					DrawFrame.redraw();
				}else if(id==4) {
					Engine.addDraw(new DrawRationalBerzie((int)parameters[0],parameters[1],(int)parameters[2],(int)parameters[3]));
					DrawFrame.redraw();
				}else if(id==5) {
					if(subid==1) {
						Engine.setDrawTranslate(parameters);
						DrawFrame.redraw();
					}else if(subid==2) {
						double[] newparameters=new double[parameters.length+1];
						for(int i=0;i<parameters.length;i++)
							newparameters[i]=parameters[i];
						newparameters[newparameters.length-1]=1;
						Engine.setSelectedVertex(newparameters);
						DrawFrame.redraw();
	//					for(int i =0;i<parameters.length;i++)
	//						System.out.println("cord " + parameters[i]);
	//					parameters=Engine.getSelectedVertex();
	//					for(int i =0;i<parameters.length;i++)
	//						System.out.println("cord after " + parameters[i]);
					}
				}else if(id==6) {
					Engine.setDrawRotate(parameters);
					DrawFrame.redraw();
				}else if(id==7) {
					Engine.setDrawScale(parameters);
					DrawFrame.redraw();
				}else if(id==8) {
					Engine.setColor(ColorPanel.getColor());
				}else if(id==12) {
					CoreConstant.DRAWCANVAS_BERZIEUSECT=(int)parameters[0];
					DrawFrame.redraw();
				}else if(id==13) {
					CoreConstant.DRAWCANVAS_BERZIEVSECT=(int)parameters[0];
					DrawFrame.redraw();
				}else if(id==14) {
					Engine.setSideDistance(parameters[0]);
					DrawFrame.redraw();
				}else if(id==15) {
					Engine.setFrontDistance(parameters[0]);
					DrawFrame.redraw();
				}else if(id==16) {
					Engine.setTopDistance(parameters[0]);
					DrawFrame.redraw();
				}else if(id==17) {
					tmpValue=Engine.getEye();
					tmpValue[0]=parameters[0];
					Engine.setEye(tmpValue);
					DrawFrame.redraw();
				}else if(id==18) {
					Engine.setDistance(parameters[0]);
					DrawFrame.redraw();
				}
			}
		}
		oneTime=true;
	}
	

}