import java.lang.Math;

public class DrawRationalBerzie extends DrawBerzie {

Matrix weights;

	public DrawRationalBerzie(int degreeX,int degreeY) {
	
	
		super(degreeX,degreeY);
		weights=new Matrix(degreeX,degreeY);
		for(int i=0;i<degreeX;i++)
			for(int j=0;j<degreeY;j++)
		 		weights.set(i,j,CoreConstant.DRAWRATIONALBERZIE_INITWEIGHT);
		type=CoreConstant.DRAWCANVAS_RATIONAL;
	}
	
	public DrawRationalBerzie(int unit,double z,int degreeX,int degreeY) {
	
	
		super(unit,z,degreeX,degreeY);
		weights=new Matrix(degreeX,degreeY);
		for(int i=0;i<degreeX;i++)
			for(int j=0;j<degreeY;j++)
		 		weights.set(i,j,CoreConstant.DRAWRATIONALBERZIE_INITWEIGHT);
		type=CoreConstant.DRAWCANVAS_RATIONAL;
	}
	
	public DrawRationalBerzie(int degreeX,int degreeY,int flag) {
	
	
		super(degreeX,degreeY,flag);
		weights=new Matrix(degreeX,degreeY);
		for(int i=0;i<degreeX;i++)
			for(int j=0;j<degreeY;j++)
		 		weights.set(i,j,CoreConstant.DRAWRATIONALBERZIE_INITWEIGHT);
		type=CoreConstant.DRAWCANVAS_RATIONAL;
	}
	
	public Matrix getWeights() {
	
		return weights;
	}
	
	public void setWeights(Matrix weights) {
	
		this.weights=weights;
	}
	
	public void setWeight(int position,double value) {
	

		int column,row;
		
			if(value>=0) {
				row=(int)Math.floor((position/degreeY));
				column=position-row*degreeY;
//				System.out.println("row: "+ row +" col: "+column +" pos " +position);
				weights.set(row,column,value);
//				System.out.println("\n"+weights);
			}
	}
	
	public double getWeight(int position) {
	

		int column,row;
		
			row=(int)Math.floor((position/degreeY));
			column=position-row*degreeY;
			return(weights.get(row,column));
	
	}
}