import java.lang.Math;

public class Geometry extends Object {

static Matrix transform=null;
static Matrix geoTransform=null,worldTransform=null;
static Matrix[] controlPoint;
static Matrix m,n,weights;
static int degreeX,degreeY;
static double[] camera;
static double distance;

	public void Geometry () {
	}
	
	public static Matrix product(Matrix factor1,Matrix factor2) {

	Matrix returnValue=null;
		
			double tempValueDouble=0.0;
				returnValue=new Matrix(factor1.row,factor2.column);
				for (int i=0;i<factor1.row;i++) 
					for(int j=0;j<factor2.column;j++){
						double[] row=factor1.getRow(i);
						double[] column=factor2.getColumn(j);
						for(int k=0;k<row.length;k++)
							tempValueDouble+=row[k]*column[k];
						returnValue.set(i,j,tempValueDouble);
						tempValueDouble=0.0;
					}
			return returnValue;
	}
	
	public static double[] product(Matrix factor1,double[] factor2) {

	double[] returnValue;
		
			double tempValueDouble=0.0;
				returnValue=new double[factor1.column];
				for (int i=0;i<1;i++) 
					for(int j=0;j<factor1.column;j++){
						double[] column=factor1.getColumn(j);
						for(int k=0;k<factor2.length;k++)
							tempValueDouble+=factor2[k]*column[k];
						returnValue[j]=tempValueDouble;
						tempValueDouble=0.0;
					}
			return returnValue;
	}
	
		
	public static void rotationZ(double alfa) {
	Matrix rotateZ=null;

		double[][] matrix=new double[4][4];
		matrix[0][0]=Math.cos(alfa);
		matrix[0][1]=Math.sin(alfa);
		matrix[1][0]=-Math.sin(alfa);
		matrix[1][1]=Math.cos(alfa);
		matrix[2][2]=1.0F;
		matrix[3][3]=1.0F;
		rotateZ=new Matrix(matrix);
		if (transform==null)
			transform=rotateZ;
		else
			transform=product(transform,rotateZ);
	}
	
	public static void rotationY(double alfa) {
	Matrix rotateY=null;
	

		double[][] matrix=new double[4][4];
		matrix[0][0]=Math.cos(alfa);
		matrix[0][2]=-Math.sin(alfa);
		matrix[2][0]=Math.sin(alfa);
		matrix[2][2]=Math.cos(alfa);
		matrix[1][1]=1.0F;
		matrix[3][3]=1.0F;
		rotateY=new Matrix(matrix);
		if (transform==null)
			transform=rotateY;
		else
			transform=product(transform,rotateY);
	}

	public static void rotationX(double alfa) {
	Matrix rotateX=null;
	
		double[][] matrix=new double[4][4];
		matrix[1][1]=Math.cos(alfa);
		matrix[1][2]=Math.sin(alfa);
		matrix[2][1]=-Math.sin(alfa);
		matrix[2][2]=Math.cos(alfa);
		matrix[0][0]=1.0F;
		matrix[3][3]=1.0F;
		rotateX=new Matrix(matrix);
		if (transform==null)
			transform=rotateX;
		else
			transform=product(transform,rotateX);
	}
	
	public static void rotate(double[] abg) {
	
		if(abg[0]!=0.0)
			rotationX(abg[0]);
		if(abg[1]!=0.0)
			rotationY(abg[1]);
		if(abg[2]!=0.0)
			rotationZ(abg[2]);			
	}

	public static void scale(double[] xyzu) {
	Matrix scale=null;
		
		double[][] matrix=new double[4][4];
		matrix[0][0]=xyzu[0];		
		matrix[1][1]=xyzu[1];
		matrix[2][2]=xyzu[2];
		matrix[3][3]=xyzu[3];
		scale=new Matrix(matrix);
		if (transform==null)
			transform=scale;
		else
			transform=product(transform,scale);
	}
	
	public static void translate(double[] xyz) {
	Matrix translate=null;
	
		double[][] matrix=new double[4][4];
		matrix[0][0]=1.0;
		matrix[1][1]=1.0;
		matrix[2][2]=1.0;
		matrix[3][3]=1.0;
		matrix[3][0]=xyz[0];		
		matrix[3][1]=xyz[1];
		matrix[3][2]=xyz[2];
		translate=new Matrix(matrix);
		if (transform==null)
			transform=translate;
		else
			transform=product(transform,translate);

	}
	
	public static void eyePerspective(double[] eye,double distance ) {
	Matrix eyePerspective=null;
	
		camera=eye;
		Geometry.distance=distance;
		double[][] matrix=new double[4][3];
		matrix[0][0]=(distance-eye[0])*Math.sin(eye[1]);		
		matrix[0][1]=(distance-eye[0])*Math.cos(eye[2])*Math.cos(eye[1]);
		matrix[0][2]=-Math.sin(eye[2])*Math.cos(eye[1]);
		matrix[1][0]=(eye[0]-distance)*Math.cos(eye[1]);		
		matrix[1][1]=(distance-eye[0])*Math.cos(eye[2])*Math.sin(eye[1]);
		matrix[1][2]=-Math.sin(eye[2])*Math.sin(eye[1]);
		matrix[2][1]=(eye[0]-distance)*Math.sin(eye[2]);
		matrix[2][2]=-Math.cos(eye[2]);
		matrix[3][2]=eye[0];
		eyePerspective=new Matrix(matrix);	
		if (transform==null)
			transform=eyePerspective;
		else
			transform=product(transform,eyePerspective);

	}


	public static void eyeImage(double[] uv) {
	Matrix image=null;
	
		double[][] matrix=new double[3][3];
		matrix[0][0]=(uv[1]-uv[0])/2;
		matrix[1][1]=(uv[3]-uv[2])/2;
		matrix[2][0]=(uv[1]+uv[0])/2;
		matrix[2][1]=(uv[3]+uv[2])/2;
		matrix[2][2]=1.0;
		image=new Matrix(matrix);
		if (transform==null)
			transform=image;
		else
			transform=product(transform,image);
	}
	
	public static void topPerspective(double l) {
	Matrix top=null;
	
		double[][] matrix=new double[4][3];
		matrix[0][0]=1/l;
		matrix[1][1]=1/l;
		matrix[3][2]=1;
		top=new Matrix(matrix);
		if (transform==null)
			transform=top;
		else
			transform=product(transform,top);
	}
	
	public static void topImage(double[] uv) {
	Matrix image=null;
	
		double[][] matrix=new double[3][3];
		matrix[0][0]=(uv[1]-uv[0])/2;
		matrix[1][1]=(uv[3]-uv[2])/2;
		matrix[2][0]=(uv[1]+uv[0])/2;
		matrix[2][1]=(uv[3]+uv[2])/2;
		matrix[2][2]=1.0;
		image=new Matrix(matrix);
		if (transform==null)
			transform=image;
		else
			transform=product(transform,image);
	}
	
	public static void sidePerspective(double l) {
	Matrix side=null;
	
		double[][] matrix=new double[4][3];
		matrix[0][0]=1/l;
		matrix[2][1]=1/l;
		matrix[3][2]=1;
		side=new Matrix(matrix);
		if (transform==null)
			transform=side;
		else
			transform=product(transform,side);
	}
	
	public static void sideImage(double[] uv) {
	Matrix image=null;
	
		double[][] matrix=new double[3][3];
		matrix[0][0]=(uv[1]-uv[0])/2;
		matrix[1][1]=(uv[3]-uv[2])/2;
		matrix[2][0]=(uv[1]+uv[0])/2;
		matrix[2][1]=(uv[3]+uv[2])/2;
		matrix[2][2]=1.0;
		image=new Matrix(matrix);
		if (transform==null)
			transform=image;
		else
			transform=product(transform,image);
	}

	public static void frontPerspective(double l) {
	Matrix front=null;
	
		double[][] matrix=new double[4][3];
		matrix[1][0]=1/l;
		matrix[2][1]=1/l;
		matrix[3][2]=1;
		front=new Matrix(matrix);
		if (transform==null)
			transform=front;
		else
			transform=product(transform,front);
	}
	
	public static void frontImage(double[] uv) {
	Matrix image=null;
	
		double[][] matrix=new double[3][3];
		matrix[0][0]=(uv[1]-uv[0])/2;
		matrix[1][1]=(uv[3]-uv[2])/2;
		matrix[2][0]=(uv[1]+uv[0])/2;
		matrix[2][1]=(uv[3]+uv[2])/2;
		matrix[2][2]=1.0;
		image=new Matrix(matrix);
		if (transform==null)
			transform=image;
		else
			transform=product(transform,image);
	}
		
	public static double[] applyTransform(double[] point) {
	
		return product(transform,point);
	}
	
	public static void clear() {
	
		transform=null;
	}
	
	public static double[] makeOmogenous(double[] point) {
	
	double[] returnValue=new double[point.length];
	
		for(int i=0;i<point.length;i++)
			returnValue[i]=point[i]/point[point.length-1];
		return returnValue;
	}
	
	public static void setGeometry() {
	
		geoTransform=transform;
		transform=null;
	}

	public static void setWorld() {
	
		worldTransform=transform;
		transform=null;
	}
	
	public static void concatenate() {
	
		if(geoTransform!=null && worldTransform!=null)
			transform=product(geoTransform,worldTransform);
		else if(geoTransform!=null)
			transform=geoTransform;
		else if(worldTransform!=null)
			transform=worldTransform;
	}

	public static int factorial(int index) {
	
		if(index==0)
			return 1;
		if(index<0)
			return 0;
		if(index>=1)
			return (index*factorial(index-1));
		return Integer.MAX_VALUE;
	}
	
	public static int binomial(int n,int k) {
	
		if(n==k)
			return 1;
		else if(k>n)
		 	return 0;
		else
			return(factorial(n)/(factorial(k)*factorial(n-k)));
	}

	public static double berstein(int i,int n,double t) {
	
		if (t>=0 && t<=1)
			return(Math.pow(t,i)*Math.pow(1.0-t,n-i)*factorial(n)/(factorial(i)*factorial(n-i)));
		else return Double.NaN;
	}

	public static double[] berzie(int n,double t,double[][] controlPoint) {

		double[] returnValue;

		if (controlPoint!=null && controlPoint[0]!=null && n==controlPoint.length-1) {
			returnValue=new double[controlPoint[0].length];
			for(int j=0;j<controlPoint[0].length;j++)
				for(int i=0;i<n+1;i++)
					returnValue[j]+=berstein(i,n,t)*controlPoint[i][j];
			return returnValue;
		}
		return null;
	
	}
	
	public static double[] getPointByMatrix(double u, double v) {

	double[] returnValue;
	double[][] vectorU=new double[1][degreeX],vectorV=new double[degreeY][1];
	Matrix matrixU,matrixV,tmpValue;

		returnValue=new double[controlPoint.length];
		for (int i=0;i<degreeX;i++)
			vectorU[0][i]=Math.pow(u,i);
		for (int i=0;i<degreeY;i++)
			vectorV[i][0]=Math.pow(v,i);
		matrixU=new Matrix(vectorU);
		matrixV=new Matrix(vectorV);
		for(int k=0;k<returnValue.length;k++) {
			tmpValue=product(matrixU,m);
			tmpValue=product(tmpValue,controlPoint[k]);
			tmpValue=product(tmpValue,n);
			tmpValue=product(tmpValue,matrixV);
			returnValue[k]=tmpValue.get(0,0);
		}
		return returnValue;
	}
	
	public static double[] getRationalPointByTensor(double u, double v) {

	double tmpPoint;
	double[] returnValue,numerator,denominator;
	double[][] vectorU=new double[1][degreeX],vectorV=new double[degreeY][1];
		
		returnValue=new double[controlPoint.length];
		numerator=new double[controlPoint.length];
		denominator=new double[controlPoint.length];
		for(int k=0;k<returnValue.length;k++)  {
			for(int i=0;i<degreeX;i++) 
				for(int j=0;j<degreeY;j++) {
					tmpPoint=controlPoint[k].get(i,j);
					numerator[k]=numerator[k]+(tmpPoint*Geometry.berstein(i,degreeX-1,u)*Geometry.berstein(j,degreeY-1,v)*weights.get(i,j));
					denominator[k]=denominator[k]+(Geometry.berstein(i,degreeX-1,u)*Geometry.berstein(j,degreeY-1,v)*weights.get(i,j));
				}
			returnValue[k]=numerator[k]/denominator[k];
		}
		
		return(returnValue);
	}
	
	
	public static double[] getPointByTensor(double u, double v) {

	double tmpPoint;
	double[] returnValue;
	double[][] vectorU=new double[1][degreeX],vectorV=new double[degreeY][1];
		
	returnValue=new double[controlPoint.length];
	for(int k=0;k<returnValue.length;k++) 
		for(int i=0;i<degreeX;i++) 
			for(int j=0;j<degreeY;j++) {
				tmpPoint=controlPoint[k].get(i,j);
				returnValue[k]=returnValue[k]+(tmpPoint*Geometry.berstein(i,degreeX-1,u)*Geometry.berstein(j,degreeY-1,v));
			}
		return(returnValue);
	}
	
	public static void setRationalBerzieControlPoint(Draw draw) {

		setBerzieControlPoint(draw);
		weights=draw.getWeights();
	}
	
	
	public static void setBerzieControlPoint(Draw draw) {
	double tmpValue;
	double[] tmpPoint;

	
		
		if (draw!=null && draw.getType()!=CoreConstant.DRAWCANVAS_POLY) {
			degreeX=draw.getDegreeX();
			degreeY=draw.getDegreeY();
			tmpPoint=draw.getVertex(0);
			controlPoint=new Matrix[tmpPoint.length];
			for(int i=0;i<controlPoint.length;i++) 
				controlPoint[i]=new Matrix(degreeX,degreeY);
			for(int k=0;k<controlPoint.length;k++)
				for(int i=0;i<degreeX;i++)
					for(int j=0;j<degreeY;j++) {
						tmpPoint=draw.getVertex(i*degreeY+j);
						controlPoint[k].set(i,j,tmpPoint[k]);
				}
		n=new Matrix(degreeY,degreeY);
		for(int i=0;i<degreeY;i++)
			for(int j=0;j<degreeY;j++)  {
				tmpValue=Math.pow(-1,j-i)*Geometry.binomial(degreeY-1,j)*Geometry.binomial(j,i);
				n.set(i,j,tmpValue);
			}
		m=new Matrix(degreeX,degreeX);
		for(int i=0;i<degreeX;i++)
			for(int j=0;j<degreeX;j++)  {
				tmpValue=Math.pow(-1,j-i)*Geometry.binomial(degreeX-1,j)*Geometry.binomial(j,i);
				m.set(j,i,tmpValue);
			}
		}
	}
	
	public static double[] getImagePlane() {
	
		double[] returnValue=new double[4];
		returnValue[0]=Math.sin(camera[2])*Math.cos(camera[1]);
		returnValue[1]=Math.sin(camera[2])*Math.sin(camera[1]);			
		returnValue[2]=Math.cos(camera[2]);
		returnValue[3]=-distance;
		return returnValue;
	}
	
//	public static boolean CheckClip(double[] vertex,int type) {
//		
//	}
	public static double[] getBaricenter(Draw draw) {
		
		double[] tmpVertex,returnValue=new double[4];
		for(int i=0;i<draw.size();i++) {
			tmpVertex=draw.getVertex(i);
			for(int j=0;j<tmpVertex.length;j++)
				returnValue[j]+=tmpVertex[j]/(double)draw.size();
		}
//		System.out.println("baricenter "+ returnValue[0] +" "+ returnValue[1]);
		return returnValue;
	}

	public static double[] findFarestVertex(Draw draw,double[] position) {

		double[] tmpVertex;
		double distance,max=0;
		int returnValue=-1;
		
		for(int i=0;i<draw.size();i++) {
			tmpVertex=draw.getVertex(i);
			distance=Math.pow(position[0]-tmpVertex[0],2.0)+Math.pow(position[1]-tmpVertex[1],2.0);
//			System.out.println("vertex " + i +" distance " +distance);
			if(distance>max) {
				max=distance;
				returnValue=i;
			}
		}
//		System.out.println("ret "+ returnValue);
		return draw.getVertex(returnValue);
	}
	
	public static double[] findNearestVertex(Draw draw,double[] position) {

		double[] tmpVertex;
		double distance,min=Double.POSITIVE_INFINITY;
		int returnValue=-1;
		
		for(int i=0;i<draw.size();i++) {
			tmpVertex=draw.getVertex(i);
			distance=Math.pow(position[0]-tmpVertex[0],2.0)+Math.pow(position[1]-tmpVertex[1],2.0);
//			System.out.println("vertex " + i +" distance " +distance);
			if(distance<min) {
				min=distance;
				returnValue=i;
			}
		}
//		System.out.println("ret "+ returnValue);
		return draw.getVertex(returnValue);
	}

	public static int findFarestVertexByPosition(Draw draw,double[] position) {

		double[] tmpVertex;
		double distance,max=0;
		int returnValue=-1;
		
		for(int i=0;i<draw.size();i++) {
			tmpVertex=draw.getVertex(i);
			distance=Math.pow(position[0]-tmpVertex[0],2.0)+Math.pow(position[1]-tmpVertex[1],2.0);
//			System.out.println("vertex " + i +" distance " +distance);
			if(distance>max) {
				max=distance;
				returnValue=i;
			}
		}
//		System.out.println("ret "+ returnValue);
		return returnValue;
	}
	
	public static int findNearestVertexByPosition(Draw draw,double[] position) {

		double[] tmpVertex;
		double distance,min=Double.POSITIVE_INFINITY;
		int returnValue=-1;
		
		for(int i=0;i<draw.size();i++) {
			tmpVertex=draw.getVertex(i);
			distance=Math.pow(position[0]-tmpVertex[0],2.0)+Math.pow(position[1]-tmpVertex[1],2.0);
//			System.out.println("vertex " + i +" distance " +distance);
			if(distance<min) {
				min=distance;
				returnValue=i;
			}
		}
//		System.out.println("ret "+ returnValue);
		return returnValue;
	}
	
	public static int findRealNearest(Draw draw,double[] position){
	
		double[] tmpVertex;
		double distance,min=Double.POSITIVE_INFINITY;
		int returnValue=-1;
		
		Geometry.setTransform(draw);
		for(int i=0;i<draw.size();i++) {
			tmpVertex=draw.getVertex(i);
			tmpVertex=Geometry.getTransformedVertex(tmpVertex);
			distance=distance(tmpVertex,position);
//			System.out.println("vertex " + i +" distance " +distance);
			if(distance<min) {
				min=distance;
				returnValue=i;
			}
		}
//		System.out.println("ret "+ returnValue);
		return returnValue;
	
	}

	public static int findRealFarest(Draw draw,double[] position){
	
		double[] tmpVertex;
		double distance,max=Double.NEGATIVE_INFINITY;
		int returnValue=-1;
		
		Geometry.setTransform(draw);
		for(int i=0;i<draw.size();i++) {
			tmpVertex=draw.getVertex(i);
			tmpVertex=Geometry.getTransformedVertex(tmpVertex);
			distance=distance(tmpVertex,position);
//			System.out.println("vertex " + i +" distance " +distance);
			if(distance>max) {
				max=distance;
				returnValue=i;
			}
		}
//		System.out.println("ret "+ returnValue);
		return returnValue;
	
	}
	
	public static double distance(double[] p1,double[] p2) {
		
		double distance=0;
		
		if(p1.length!=p2.length)
			return Double.NaN;
		for(int i=0;i<p1.length-1;i++)
			distance+=Math.pow((p1[i]-p2[i]),2.0);
//		System.out.println("distance "+distance);
		return Math.sqrt(distance);
			
	}
	
	public static double distance2d(double[] p1,double[] p2) {
		
		double distance=0;
		
		if(p1.length!=2 && p2.length!=2)
			return Double.NaN;
		for(int i=0;i<p1.length-1;i++)
			distance+=Math.pow((p1[i]-p2[i]),2.0);
//		System.out.println("distance "+distance);
		return Math.sqrt(distance);
			
	}
	
	public static double getMagnitudo(double[] vector) {
		
		double returnValue=0;
		
		for(int i=0;i<vector.length-1;i++)
			returnValue+=Math.pow(vector[i],2.0);
		return Math.sqrt(returnValue);
		
	}
	
	public static double[] cross(double[] p1,double[] p2) {
		
		double[] p3=new double[4];
		
		p3[0]=p1[1]*p2[2]-p1[2]*p2[1];
		p3[1]=-(p1[0]*p2[2]-p1[2]*p2[0]);
		p3[2]=p1[0]*p2[1]-p1[1]*p2[0];
		p3[3]=1;
		return p3;
	}
	
	
	public static void setTransform(Draw draw){
		
		double[] rotation=draw.getRotate();
		double[] scale=draw.getScale();
		double[] translate=draw.getTranslate();
		
		Geometry.clear();
		Geometry.scale(scale);
		Geometry.rotate(rotation);
		Geometry.translate(translate);
	}
	
	public static double[] getTransformedVertex(double[] vertex){
		
		return(Geometry.product(transform,vertex));
		
	}
	
	public static double dotProduct(double[] v1,double[] v2){
		
		double returnValue=0;
		
		if(v1.length!=v2.length)
			return Double.NaN;
		else
			for(int i=0;i<v1.length-1;i++)
				returnValue+=v1[i]*v2[i];
		return returnValue;
	}
	
	public static double[] normalize(double[] vector){
	
		double[] returnValue;
		double tmpValue;
		
		returnValue=new double[vector.length];
		tmpValue=getMagnitudo(vector);
		for(int i=0;i<vector.length;i++)
			returnValue[i]=vector[i]/tmpValue;
		return returnValue;
	}
	
	public static double[] getBaricenter(double[][] vertex){
		
		double[] returnValue=new double[vertex[0].length];
		
		for(int i=0;i<vertex.length;i++)
			for(int j=0;j<vertex[i].length;j++)
					returnValue[j]+=vertex[i][j]/vertex.length;
		return returnValue;
	}
	
	public static double cos(double[] v1,double[] v2){
		
		double returnValue,magnitudo;
		double tmpValue;
		
		tmpValue=dotProduct(v1,v2);
		magnitudo=getMagnitudo(v1);
		returnValue=getMagnitudo(v2);
		returnValue=tmpValue/(magnitudo*returnValue);
		return returnValue;
	}
	
	public static double[] plus(double[] v1,double[] v2){
		
		double[] returnValue=new double[v1.length];
		
		if(v1.length!=v2.length)
			return null;
		for(int i=0;i<v1.length-1;i++)
			returnValue[i]=v1[i]+v2[i];
		return returnValue;
	}
	
	public static double[] minus(double[] v1,double[] v2){
	
		double[] returnValue=new double[v1.length];
		
		if(v1.length!=v2.length)
			return null;
		for(int i=0;i<v1.length-1;i++)
			returnValue[i]=v1[i]-v2[i];
		return returnValue;
	}
	
	public static double[] pointToVector(double[] v1,double[] v2){
	
			return(minus(v1,v2));
	}
	
	public static double[] valueProduct(double[] v1,double value){
		
		double[] returnValue;
		
		returnValue=new double[v1.length];
		for(int i=0;i<v1.length-1;i++)
			returnValue[i]=v1[i]*value;
		returnValue[v1.length-1]=v1[v1.length-1];
		return returnValue;
	}
	
	public static boolean isEqual(double[] v1,double[] v2){
	
		if(v1.length!=v2.length)
			return false;
		else
			for(int i=0;i<v1.length;i++)
				if(v1[i]!=v2[i])
					return false;
		return true;
	}
	
	public static boolean isNearlyEqual(double[] v1,double[] v2){
	
		if(v1.length!=v2.length)
			return false;
		else
			for(int i=0;i<v1.length;i++)
				if(v1[i]<v2[i]-CoreConstant.COLLISIONENGINE_NZERO || v1[i]>v2[i]+CoreConstant.COLLISIONENGINE_NZERO)
					return false;
		return true;
	}
	
	public static double[] intersectionPE(double[] normal,double[] origin,double[] p1,double[] p2){
	
		double[] returnValue,plane;
		double denominator=0,numerator=0,t=0;
		
		plane=new double[4];
		plane[0]=normal[0];
		plane[1]=normal[1];
		plane[2]=normal[2];
		plane[3]=-(normal[0]*origin[0]+normal[1]*origin[1]+normal[2]*origin[2]);
		denominator=plane[0]*(p2[0]-p1[0])+plane[1]*(p2[1]-p1[1])+plane[2]*(p2[2]-p1[2]);
		numerator=plane[0]*p2[0]+plane[1]*p2[1]+plane[2]*p2[2]+plane[3];
		t=numerator/denominator;
		if(t<=1 && t>=0){
			returnValue=new double[4];
			returnValue[0]=p2[0]-t*(p2[0]-p1[0]);
			returnValue[1]=p2[1]-t*(p2[1]-p1[1]);
			returnValue[2]=p2[2]-t*(p2[2]-p1[2]);
			returnValue[3]=1.0;
			return returnValue;
		}else
			return null;
	}
	
	public static boolean belongsAP(double[] p1,double[] p2,double[] p3,double[] p){
		
		double[][] vectorPP;
		double[] vectorVP,angleVP;
		double anglePP;
		
		vectorPP=new double[2][];
		angleVP=new double[2];
		
		vectorPP[0]=Geometry.pointToVector(p1,p2);
		vectorPP[1]=Geometry.pointToVector(p1,p3);
		vectorVP=Geometry.pointToVector(p1,p);
		angleVP[0]=Geometry.cos(vectorPP[0],vectorVP);
		angleVP[1]=Geometry.cos(vectorPP[1],vectorVP);
		angleVP[0]=Math.acos(angleVP[0]);
		angleVP[1]=Math.acos(angleVP[1]);
		anglePP=Geometry.cos(vectorPP[1],vectorPP[0]);
		anglePP=Math.acos(anglePP);
		if(angleVP[0]<anglePP && angleVP[1]<anglePP){
			vectorPP[0]=Geometry.pointToVector(p2,p1);
			vectorPP[1]=Geometry.pointToVector(p2,p3);
			vectorVP=Geometry.pointToVector(p2,p);
			angleVP[0]=Geometry.cos(vectorPP[0],vectorVP);
			angleVP[1]=Geometry.cos(vectorPP[1],vectorVP);
			angleVP[0]=Math.acos(angleVP[0]);
			angleVP[1]=Math.acos(angleVP[1]);
			anglePP=Geometry.cos(vectorPP[1],vectorPP[0]);
			anglePP=Math.acos(anglePP);
			if(angleVP[0]<anglePP && angleVP[1]<anglePP)
				return true;
		}
		return false;
	}
	
	public static double distancePP(double[] normal,double[] origin,double[] p){
	
		double[] plane;
		double distance=-1;
		/*System.out.println("------------------------");
		System.out.println("------------------------");
		System.out.println("------------------------");
		for(int i=0;i<p.length;i++)
			System.out.println(p[i]);*/
		plane=new double[4];
		plane[0]=normal[0];
		plane[1]=normal[1];
		plane[2]=normal[2];
		plane[3]=-(normal[0]*origin[0]+normal[1]*origin[1]+normal[2]*origin[2]);
		distance=plane[0]*p[0]+plane[1]*p[1]+plane[2]*p[2]+plane[3];
		return distance;
	}
	
	public static boolean valid(double[] point){
		
		if(point.length!=4)
			return false;
		for(int i=0;i<4;i++)
			if(point[i]==Double.NaN || point[i]==Double.NEGATIVE_INFINITY || point[i]==Double.POSITIVE_INFINITY)
				return false;
		return true;
	}
}