import java.awt.Color;
import java.awt.Font;
/*
 * applet.java
 *
 * Created on 20 febbraio 2003, 15.46
 */

/**
 *
 * @author  mason
 */
public class applet extends java.applet.Applet {

	DrawFrame drawFrame;
	ColorFrame color;
	ParameterFrame parameterFrame;
	
	/** Initialization method that will be called after the applet is loaded
	 *  into the browser.
	 */
	public void init() {
	
		double[] eye={110,0,0};
		double[] uv={0,Constant.DRAWCANVAS_HEIGHT,0,Constant.DRAWCANVAS_WIDTH};
		
		Engine.setEye(eye);
		Engine.setDistance(100.0);
		Engine.setUV(uv);
		Engine.setTopDistance(3.0);
		Engine.setSideDistance(3.0);
		Engine.setFrontDistance(3.0);
		drawFrame=new DrawFrame(0,Color.blue,Color.lightGray,new Font("Georgia", Font.ITALIC, 14));
		drawFrame.off();
		color=new ColorFrame(Color.blue,Color.lightGray,new Font("Georgia", Font.ITALIC, 14));
		ColorFrame.off();
		parameterFrame=new ParameterFrame(Color.blue,Color.lightGray,new Font("Georgia", Font.ITALIC, 14));
		parameterFrame.off();
		Engine.addDraw(new DrawGrid());
		Engine.addDraw(new DrawAxis());
	}
	
	public void start(){
		

		DrawFrame.on();
	}
	
	public void stop(){
		
		DrawFrame.off();
	}
		
	public void destroy(){
		
		Engine.flush();
		System.gc();
	}
}
