public class DrawGrid extends Draw {

	public DrawGrid() {
	

		super();
		double[][] grid=new double[4*CoreConstant.DRAWGRID_SUBDIVISION-4][4];
		int[] neighbour=new int[1];
		int[] neighbours;
		for(int i=0;i<CoreConstant.DRAWGRID_SUBDIVISION;i++)  {
			grid[i][0]=CoreConstant.DRAWGRID_STARTX+((CoreConstant.DRAWGRID_ENDX-CoreConstant.DRAWGRID_STARTX)/(CoreConstant.DRAWGRID_SUBDIVISION-1))*i;
			grid[i][1]=CoreConstant.DRAWGRID_STARTY;
			grid[i][2]=CoreConstant.DRAWGRID_Z;
			grid[i][3]=1;
			neighbour[0]=CoreConstant.DRAWGRID_SUBDIVISION+i;
//			System.out.println(grid[i][0]+ " "+grid[i][1]+" "+grid[i][2]+" "+grid[i][3]+"   " + neighbour[0]+"\n");
			vertex.add(new DrawElement(grid[i],((int[])neighbour.clone())));
		}

		for(int i=CoreConstant.DRAWGRID_SUBDIVISION;i<2*CoreConstant.DRAWGRID_SUBDIVISION;i++)  {
			grid[i][0]=(CoreConstant.DRAWGRID_STARTX+(CoreConstant.DRAWGRID_ENDX-CoreConstant.DRAWGRID_STARTX)/(CoreConstant.DRAWGRID_SUBDIVISION-1)*(i-CoreConstant.DRAWGRID_SUBDIVISION));
			grid[i][1]=CoreConstant.DRAWGRID_ENDY;
			grid[i][2]=CoreConstant.DRAWGRID_Z;
			grid[i][3]=1;
			neighbour[0]=i-CoreConstant.DRAWGRID_SUBDIVISION;
//			System.out.println(grid[i][0]+ " "+grid[i][1]+" "+grid[i][2]+" "+grid[i][3]+"   " +neighbour[0]+"\n");
			vertex.add(new DrawElement(grid[i],((int[])neighbour.clone())));	
		}	
	
		for(int i=2*CoreConstant.DRAWGRID_SUBDIVISION;i<3*CoreConstant.DRAWGRID_SUBDIVISION-2;i++)  {
			grid[i][0]=CoreConstant.DRAWGRID_STARTX;
			grid[i][1]=CoreConstant.DRAWGRID_STARTY+(CoreConstant.DRAWGRID_ENDY-CoreConstant.DRAWGRID_STARTY)/(CoreConstant.DRAWGRID_SUBDIVISION-1)*(i+1-2*CoreConstant.DRAWGRID_SUBDIVISION);
			grid[i][2]=CoreConstant.DRAWGRID_Z;
			grid[i][3]=1;
			neighbour[0]=i+CoreConstant.DRAWGRID_SUBDIVISION-2;
//			System.out.println(grid[i][0]+ " "+grid[i][1]+" "+grid[i][2]+" "+grid[i][3]+"   " +neighbour[0]+"\n");
			vertex.add(new DrawElement(grid[i],((int[])neighbour.clone())));	
		}

		for(int i=3*CoreConstant.DRAWGRID_SUBDIVISION-2;i<4*CoreConstant.DRAWGRID_SUBDIVISION-4;i++)  {
			grid[i][0]=CoreConstant.DRAWGRID_ENDX;
			grid[i][1]=(CoreConstant.DRAWGRID_STARTY+(CoreConstant.DRAWGRID_ENDY-CoreConstant.DRAWGRID_STARTY)/(CoreConstant.DRAWGRID_SUBDIVISION-1)*(i+1-3*CoreConstant.DRAWGRID_SUBDIVISION+2));
			grid[i][2]=CoreConstant.DRAWGRID_Z;
			grid[i][3]=1;
			neighbour[0]=i-CoreConstant.DRAWGRID_SUBDIVISION+2;
//			System.out.println(grid[i][0]+ " "+grid[i][1]+" "+grid[i][2]+" "+grid[i][3]+"   "+ neighbour[0]+"\n");
			vertex.add(new DrawElement(grid[i],((int[])neighbour.clone())));
			neighbour[0]=CoreConstant.DRAWGRID_SUBDIVISION-1;
			addNeighbours(getVertex(0),((int[])neighbour.clone()));
			neighbour[0]=CoreConstant.DRAWGRID_SUBDIVISION;
			addNeighbours(getVertex(2*CoreConstant.DRAWGRID_SUBDIVISION-1),((int[])neighbour.clone()));
			setColor(CoreConstant.DRAWGRID_COLOR);
		}
	}

}