class Matrix {

	double[][] matrix;
	public int row;
	public int column;

	
	public Matrix(int degree) {
		
		matrix=new double[degree][degree];
		row=degree;
		column=degree;
	}
	
	public Matrix(int row,int column) {
	
		matrix=new double[row][column];
		this.row=row;
		this.column=column;
	}
		
	public Matrix(double[][] matrix) {
	
		this.matrix=matrix;
		row=matrix.length;
		column=matrix[0].length;
	}
	
	
	public double[][] get() {
	
			return matrix;
	}

	
	public String toString() {
	String returnValue=new String();
	

			for(int i=0;i<matrix.length;i++) {
				for(int j=0;j<matrix[i].length;j++) 
					returnValue+=matrix[i][j] + " ";
				returnValue+="\n";
			}
		return returnValue;
	}
	
	public double[] getRow(int row) {
	
		if(row<this.row)
			return matrix[row];
		return null;
	}


	public double[] getColumn(int column) {
	
	double[] returnValue=new double[matrix.length];
	
		if (column<this.column) {
			for(int i=0;i<matrix.length;i++)
				returnValue[i]=matrix[i][column];
		return returnValue;
		}
		return null;
	}

	public boolean set(int row,int column,double value) {
			
		if(column<this.column && column>=0 && row<this.row && row>=0)
				matrix[row][column]=value;
			else return false;
		return true;
	}
	
	public double get(int row,int column) {
	
		if(column<this.column && column>=0 && row<this.row && row>=0)
				return matrix[row][column];
		return 0.0;
	}
	

}