import java.awt.Panel;
import java.awt.Label;
import java.awt.TextField;
import java.awt.Button;
import java.awt.GridLayout;
import java.awt.FlowLayout;

public class ParameterPanel extends Panel {
	
Label[] label;
static TextField[] textField;
static Button okButton,applyButton,cancelButton;
Panel centralPanel,downPanel;
ParameterAdapter parameterAdapter;
	public ParameterPanel() {
		
		downPanel=new Panel();
		downPanel.setLayout(new FlowLayout(FlowLayout.RIGHT));
		
		parameterAdapter=new ParameterAdapter();
		
		okButton=new Button(Constant.OK);
		okButton.addActionListener(parameterAdapter);
		
		cancelButton=new Button(Constant.CANCEL);
		cancelButton.addActionListener(parameterAdapter);
				
		applyButton=new Button(Constant.APPLY);
		applyButton.addActionListener(parameterAdapter);
				
		downPanel.add(cancelButton);
		downPanel.add(applyButton);
		downPanel.add(okButton);
		
		centralPanel=new Panel();
		
		this.setLayout(new GridLayout(2,1));
		
	}
	
	public void getParameter(String[] string,double[] values) {
		
		centralPanel.removeAll();
		centralPanel.setLayout(new GridLayout(string.length,2));
		label=new Label[string.length];
		textField=new TextField[string.length];
		for(int i=0;i<string.length;i++) {
			label[i]=new Label(string[i]);
			textField[i]=new TextField(Constant.PARAMETERPANEL_COLUMNS);
			textField[i].setText(Double.toString(values[i]));
			centralPanel.add(label[i]);
			centralPanel.add(textField[i]);
		}
		this.add(centralPanel);
		this.add(downPanel);
	}
	
	public static double[] returnValues() {

	double[] returnValue=new double[textField.length];
	
		for(int i=0;i<textField.length;i++)
			returnValue[i]=Double.parseDouble(textField[i].getText());
		return returnValue;

	}
}